// applet tcpbw100  4.11  thd@ornl.gov  ffowler@cs.utk.edu
// use java/misc/tcpbw100.html
// from command line:  java Tcpbw100 hostname
//  connect three times to server, 10s outbound and inbound tests
// first port for control, get web100 stats from server
import java.io.*;
import java.net.*;
import java.net.Socket;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.applet.*;
import java.util.*;

public class Tcpbw100 extends Applet implements ActionListener 
{
	TextArea results, diagnosis;
	String inresult, outresult, errmsg, host;
	Button startTest;
	Button disMiss;
	Button deTails;
	Label lab1, lab2, lab3, lab4;
	boolean Randomize,failed;
	boolean isapplet = true;
	URL location;
	Frame f;
	String s;
	Frame frame;
	double avgrtt, t;
	int SACKEnabled, TimestampsEnabled, WinScaleRcvd;
	int MinRTT, SmoothedRTT,SndLimTimeRwin,SndLimTimeCwnd,SndLimTimeSender,
	    pkts,lth=8192,
	    CurMSS,
	    Timeouts,
	    PktsRetrans,
	    SACKsRcvd,
	    CongestionSignals,
	    MaxRwinRcvd,
	    MaxRwinSent,
	    PktsOut,
	    WinScaleSent,
	    LimRwin, LimCwnd;
        public void init()
        {
	  this.setFont( new Font( "Helvetica", Font.PLAIN, 10));
	  setLayout(new FlowLayout(FlowLayout.CENTER, 5, 5));
          if (isapplet) showStatus("Tcpbw100 ready");
	  failed = false ;
	  Randomize = false;
	  results = new TextArea("TCP/Web100 bandwidth test v4.11\n",20,50);
	  results.setBackground(Color.yellow);
	  results.setEditable(false);
	  add(results);
	  results.append("click START to begin\n");
	  startTest = new Button(" START ");
	  startTest.addActionListener(this);
	  add(startTest);
	  deTails = new Button("MORE DETAILS...");
	  deTails.addActionListener(this);
	  add(deTails);
    	  deTails.setEnabled(false);
        } 
 
  
    public void runtest()
    {
	        diagnose();
		startTest.setEnabled(false);
    	        deTails.setEnabled(false);
		try {
		dottcp();
		} catch(IOException e) {
		  System.out.println (e);
		  failed=true;
		  errmsg = "Server not responding\n";
	        }
		if (failed) results.append(errmsg);
    		deTails.setEnabled(true);
                if (isapplet) showStatus("Tcpbw100 done");
    		results.append("\n click START to re-test\n");
		startTest.setEnabled(true);
    }

    public void dottcp() throws IOException {

        Socket ctlSocket = null;
        Socket outSocket = null;
	Socket inSocket = null;
	//String host = getCodeBase().getHost();
	int ctlport = 3005,  outport, inport, inlth, bytes;
	byte buff[] = new byte[8192];
	double stop_time;
	int sbuf, rbuf;

	if (isapplet) host = getCodeBase().getHost();
	failed = false;
        try {
            ctlSocket = new Socket(host, ctlport);
        } catch (UnknownHostException e) {
            System.err.println("Don't know about host: " + host);
	    errmsg = "unknown server\n" ;
            failed = true;
	    return;
        } catch (IOException e) {
            System.err.println("Couldn't get the connection to: " + host + " " +ctlport);
	    errmsg = "server not responding\n" ;
            failed = true;
            return;
        }
		
        InputStream ctlin = ctlSocket.getInputStream();

	inlth= ctlin.read(buff,0,buff.length); 
	if (inlth <= 0) {  
	    System.err.println("get 2nd port read failed");
	    errmsg = "server not responding ctl\n" ;
            failed = true;
	    return;
	}
	String tmpstr = new String(buff,0,inlth);
	System.out.println("server ports " + tmpstr);
	int k = tmpstr.indexOf(" ");
	outport = Integer.parseInt(tmpstr.substring(0,k));
	inport = Integer.parseInt(tmpstr.substring(k+1));

	f.toBack();

        if (isapplet) showStatus("Tcpbw100 outbound test...");
        try {
            outSocket = new Socket(host, outport);
        } catch (UnknownHostException e) {
            System.err.println("Don't know about host: " + host);
	    errmsg = "unknown server\n" ;
            failed = true;
	    return;
        } catch (IOException e) {
            System.err.println("Couldn't get 2nd connection to: " + host);
	    errmsg = "server not responding 2\n" ;
            failed = true;
            return;
        }
	results.append("running 10s outbound test...");
		
	OutputStream out = outSocket.getOutputStream();
	Random rng = new Random();
	outSocket.setSoTimeout(15000); 
	pkts=0;
	t = System.currentTimeMillis();
	stop_time = t + 10000; // ten seconds
        do {
		if (Randomize) rng.nextBytes(buff);
		out.write(buff,0,lth);
		pkts++;
	} while (System.currentTimeMillis() < stop_time);
	t =  System.currentTimeMillis() - t;
	out.close();
        outSocket.close();
	System.out.println(8*pkts*lth/t + " Kbs outbound");

	inlth= ctlin.read(buff,0,buff.length); 
	if (inlth <= 0) {  
	    System.err.println("2nd connection failed");
	    errmsg = "server not responding\n" ;
            failed = true;
	    return;
	}
	String srvresult = new String(buff,0,inlth);
	System.out.println(srvresult + " got " + inlth );
	results.append(srvresult);

        if (isapplet) showStatus("Tcpbw100 inbound test...");

        try {
            inSocket = new Socket(host, inport);
        } catch (UnknownHostException e) {
            System.err.println("Don't know about host: " + host);
	    errmsg = "unknown server\n" ;
            failed = true;
	    return;
        } catch (IOException e) {
            System.err.println("Couldn't get 3rd connection to: " + host);
	    errmsg = "server not responding 3\n" ;
            failed = true;
	    return;
        }
	results.append("\nrunning 10s inbound test...   ");

        InputStream srvin = inSocket.getInputStream();
	bytes=0;
        t = System.currentTimeMillis();

	try {  
        while ((inlth=srvin.read(buff,0,buff.length)) > 0) {
                bytes += inlth;
        }
        } catch (IOException e) {
        }

        t =  System.currentTimeMillis() - t;
        System.out.println(bytes + " bytes " + 8*bytes/t + " Kbs " + t/1000 + " secs");
	inresult = (int)(8*bytes/t) + " Kbs inbound\n";
	results.append(inresult);

        inSocket.close();
        srvin.close();

	/* get web100 variables from server */
	tmpstr = "";
	try {  
        while ((inlth= ctlin.read(buff,0,buff.length)) > 0) {
                tmpstr += new String(buff,0,inlth);
        }
        } catch (IOException e) {
        }
	ctlin.close();
        ctlSocket.close();

	testResults(tmpstr);
    }

  public void testResults(String tmpstr) {
	StringTokenizer tokens;
	int i=0;
	String sysvar, strval;
	int sumtimes, sysval, Zero=0, bwdelay, sndrwin, minwin;
	float rttsec;

        tokens = new StringTokenizer(tmpstr);
	sysvar = new String();
	strval = new String();
        while(tokens.hasMoreTokens()) {
          if(++i%2 == 1) {
	    sysvar = tokens.nextToken();
	  }
          else {
	    strval = tokens.nextToken();
            diagnosis.append(sysvar + " " + strval + "\n");
	    sysval = Integer.parseInt(strval);
	    save_values(sysvar, sysval);
	  }
        }
	results.append("\n     Web100 Inbound Summary: \n");
	  results.append("Packets to your host:  " + Integer.toString(PktsOut) );
	  results.append("  of size " + Integer.toString(CurMSS) + " bytes\n");
          results.append("average RTT: " 
	    + Double.toString(SmoothedRTT) + " ms" );
          results.append("  minimum RTT: " 
	    + Double.toString(MinRTT) + " ms\n" );
	  rttsec =  1;
	  if (MinRTT > 0) rttsec = MinRTT;
	  if (WinScaleSent > 0) sndrwin = (int)Math.pow(2,16+WinScaleSent);
	    else sndrwin = 65535;
	  minwin = (MaxRwinRcvd < sndrwin) ? MaxRwinRcvd : sndrwin;
	  bwdelay = (int)(((minwin*8)/rttsec)*1.e-3); 
	  results.append("Maximum Expected Bandwidth: " 
		+ Integer.toString(bwdelay) + " Mbs\n");  
	  sumtimes = SndLimTimeCwnd + SndLimTimeSender + SndLimTimeRwin;
	  results.append("Inbound limits:\n    congestion " +
	    Integer.toString(100*SndLimTimeCwnd/sumtimes) + "% server: " +
	    Integer.toString(100*SndLimTimeSender/sumtimes) + "% your host: " +
	    Integer.toString(100*SndLimTimeRwin/sumtimes) + "%\n");

	if(PktsRetrans > Zero) {
	  results.append("Bummer!\n     packets retransmitted: "
	  + Integer.toString(PktsRetrans) + 
	  "  congestion events: " +  Integer.toString(CongestionSignals) +
	    " \n");
	  if(Timeouts > 0) 
	    results.append("       Timeouts: " + Integer.toString(Timeouts) + "\n");   
	} else {
	  results.append("Good Data Stream--No retransmits!\n");
	}
	results.append("Your host's receive buffer: " + 
	    Integer.toString(MaxRwinRcvd) + " bytes\n");

	results.append("Server's send buffer: " +
	    Integer.toString(LimCwnd) + " bytes\n");
	results.append("            receive buffer: " + 
	    Integer.toString(sndrwin) + " bytes\n");

        results.append("  Buffer sizes are very important in determining \n");
        results.append("  network performance.  Larger buffer sizes can\n");
	results.append("  help increase thruput.  If your buffer is smaller\n");
        results.append("  than the remote host, you should investigate\n");
        results.append("  increasing your socket buffer sizes.\n");
	results.append("\n     Web100 reports Tweakable Settings as: \n");
      results.append("RFC 2018 Selective Acknowledgment: ");
      if(SACKEnabled == Zero)
         results.append ("OFF\n");
      else
         results.append ("ON\n");
    
      results.append("RFC 1323 Time Stamping: ");
      if(TimestampsEnabled == 0)
         results.append ("OFF\n");
      else
         results.append ("ON\n");
     
      results.append("RFC 1323 Window Scaling: ");
      if(WinScaleRcvd == 0)
         results.append ("OFF\n");
      else
         results.append ("ON\n");

  }

  public void save_values(String sysvar, int sysval) {
/*  Values saved for interpretation: */   
  
    if(sysvar.equals("SACKEnabled:")) 
	SACKEnabled = sysval;
    else
    if(sysvar.equals("TimestampsEnabled:")) 
	TimestampsEnabled = sysval;
    else
    if(sysvar.equals("WinScaleRcvd:")) 
	WinScaleRcvd = sysval;
    else
    if(sysvar.equals("SmoothedRTT:")) 
	SmoothedRTT = sysval;
    else
    if(sysvar.equals("SndLimTimeRwin:")) 
	SndLimTimeRwin = sysval/100000;
    else
    if(sysvar.equals("SndLimTimeCwnd:")) 
	SndLimTimeCwnd = sysval/100000;
    else
    if(sysvar.equals("SndLimTimeSender:")) 
	SndLimTimeSender = sysval/100000;
    else
    if(sysvar.equals("MinRTT:")) 
	MinRTT = sysval;
    else
    if(sysvar.equals("CurMSS:"))
	CurMSS = sysval;
    else
    if(sysvar.equals("Timeouts:")) 
	Timeouts = sysval;
    else
    if(sysvar.equals("PktsRetrans:")) 
	PktsRetrans = sysval;
    else
    if(sysvar.equals("SACKsRcvd:")) 
	SACKsRcvd = sysval;
    else
    if(sysvar.equals("CongestionSignals:")) 
	CongestionSignals = sysval;
    else
    if(sysvar.equals("MaxRwinRcvd:")) 
	MaxRwinRcvd = sysval;
    else
    if(sysvar.equals("MaxRwinSent:")) 
	MaxRwinSent = sysval;
    else
    if(sysvar.equals("LimCwnd:")) 
	LimCwnd = sysval;
    else
    if(sysvar.equals("LimRwin:")) 
	LimRwin = sysval;
    else
    if(sysvar.equals("PktsOut:")) 
	PktsOut = sysval;
    else
    if(sysvar.equals("WinScaleSent:")) 
	WinScaleSent = sysval;
  }

  public void diagnose() {
    int i;
   
    if (isapplet) showStatus("Get WEB100 Variables");
    f = new Frame("WEB100 Variables");
    disMiss = new Button("DISMISS");
    disMiss.addActionListener(this);
    diagnosis = new TextArea("WEB100 Kernel Variables:\n", 15,30);
    diagnosis.setBackground(Color.yellow);
    diagnosis.setEditable(false);
    disMiss.setEnabled(true);
    f.add("South", disMiss);
    f.add("North", diagnosis);
    f.pack();
  }

  public void actionPerformed(ActionEvent event) {
	Object source = event.getSource();
	if (source == startTest) {
		if(f != null) {
		  f.toBack();
		  f.dispose();
		  f = null;
		}
		runtest();
	}
	else
	if (source == deTails) {
		f.show();
    	        deTails.setEnabled(false);
	}
	else
	if (source == disMiss) {
		f.toBack();
		f.dispose();
		f = null;
	}
  }

    public static void main(String args[]) {
        Frame f = new Frame("Tcpbw100");
        Tcpbw100 bob = new Tcpbw100();
	bob.isapplet = false;
	if (args.length > 0) bob.host = args[0];
	else bob.host = "localhost";

        bob.init();
        bob.start();

        f.add("Center", bob);
        f.setSize(350, 350);
        f.show();
    }

}
